/*
 ============================================================================
 Name		: CenRepObserver.h
 Author	  : Usanov-Kornilov Nikolay (aka Kolay)
 Version	 : 1.0
 Copyright   : 
 Contacts:
 kolayuk@mail.ru
 http://kolaysoft.ru

 (c) KolaySoft, 2010

 Description : CCenRepObserver declaration
 ============================================================================
 */

#ifndef CENREPOBSERVER_H
#define CENREPOBSERVER_H

// INCLUDES
#include <e32std.h>
#include <e32base.h>
#include "server.h"

class CRepository; //forward declaration
class CClass;
//a observer interface for profile change
//These active objects observe the changing of the profile
//and notify the observer when the change has occured
class CCenRepObserver : public CClass
       {
       public:
               static CCenRepObserver* NewL( CClass& aObserver);
               static CCenRepObserver* NewLC(CClass& aObserver);
                void StartObservingL();
                void StopObserving();
                virtual ~CCenRepObserver();
                void RunL();
                void RunErrorL(TInt aError);
                void DoCancel();
                CCenRepObserver(CClass& aObserver);
                void ConstructL(TInt aKey, TInt aDefault);
       private:
              CRepository*  iRepository;
              TUint32       iKey;
              TUid          iUid;
              CClass&  iObserver; //class using the observer
        };
#endif // CENREPOBSERVER_H
