/*
 ============================================================================
 Name		: CenRepObserver.cpp
 Author	  : Usanov-Kornilov Nikolay (aka Kolay)
 Version	 : 1.0
 Copyright   : 
 Contacts:
 kolayuk@mail.ru
 http://kolaysoft.ru

 (c) KolaySoft, 2010

 Description : CCenRepObserver implementation
 ============================================================================
 */

#include <profileenginesdkcrkeys.h>
#include <centralrepository.h>
#include <CenRepObserverS.h>
#include "SysApAppUi.h"


//trivial NewL and NewLC have been omitted.
void CCenRepObserverS::ConstructL(TInt aKey, TDesC16& aDefault)
        {
        iUid = TUid::Uid(0x1FFF58F3); //observe SYSAP2.0 Settings Repository
        iKey = aKey; 
        
        TRAPD(err, iRepository = CRepository::NewL( iUid ) );
        
        if (err == KErrNone)
            {

            CActiveScheduler::Add(this);
        
            StartObservingL();
            RunL();
            }
        else
            {
            iObserver.StringChanged(iKey, aDefault);
            }
         }
CCenRepObserverS::CCenRepObserverS(CSysApAppUi& aObserver) : iObserver(aObserver), CActive (EPriorityLow)
         {
         //do nothing
         }
CCenRepObserverS::~CCenRepObserverS()
         {
         Cancel(); //first cancel because iRepository is used there
         delete iRepository;
         iRepository=NULL;
         }
void CCenRepObserverS::StartObservingL()
         {
         if( IsActive() )
         {
         return; //do nothing if allready observing
         }
         User::LeaveIfError(
                        iRepository->NotifyRequest( iKey, iStatus ) );
         SetActive();
          }
void CCenRepObserverS::StopObserving()
          {
          Cancel();
          }
void CCenRepObserverS::DoCancel()
          {
          iRepository->NotifyCancel(iKey);
          }
void CCenRepObserverS::RunL()
          {
          TBuf16<255> value;
          TInt error = iRepository->Get( iKey, value);
          //always check the error code
          if( error == KErrNone )
                 {
                 //observer received the profile value as integer
                 //this happens even if the value hasnt really changed
                 //some application may have set the same value again
                 iObserver.StringChanged(iKey, value);
                 }
          // Re-subscribe
          error = iRepository->NotifyRequest( iKey, iStatus );
          if( error == KErrNone )
               {
               //
               SetActive();
                }
          else
                {
                //todo: error handling
                }
           }

